/*
    GT Window: Direct3D 9 Edition
    Copyright (C) 2006 G-Truc Creation (www.g-truc.net)

    Christophe [Groove] Riccio
    contact@g-truc.net
*/

template <typename T> 
T* gtw::singleton<T>::m_pInstance = 0;

template <typename T> 
T* gtw::singleton<T>::instance()
{
	if(m_pInstance == 0)
		m_pInstance = new T;
	return m_pInstance;
}

template <typename T> 
void gtw::singleton<T>::destroy()
{
	if(m_pInstance != 0)
	{
		delete m_pInstance;
		m_pInstance = 0;
	}
}

template <typename T> 
bool gtw::singleton<T>::isCreated()
{
    return m_pInstance != 0;
}
